Public Class Form1
    Inherits System.Windows.Forms.Form

    Private Declare Function lstrcpy Lib "Kernel" (ByVal lpszString1 As Object, ByVal lpszString2 As Object) As Integer

    Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Object, ByVal Source As Object, ByVal Length As Integer)


    Private Declare Function ApCreate Lib "texttopdf.dll" Alias "apCreate" (ByVal lpFileName As String) As Integer
    Private Declare Function ApOpen Lib "texttopdf.dll" Alias "apOpen" (ByVal lpFileName As String) As Integer
    Private Declare Sub ApClose Lib "texttopdf.dll" Alias "apClose" (ByVal id As Integer)
    Private Declare Function ApAddTextEx Lib "texttopdf.dll" Alias "apAddTextEx" (ByVal id As Integer, ByVal x As Integer, ByVal y As Integer, ByVal str As String, ByVal color As Integer) As Integer
    Private Declare Function ApAddText Lib "texttopdf.dll" Alias "apAddText" (ByVal id As Integer, ByVal x As Integer, ByVal y As Integer, ByVal width As Integer, ByVal height As Integer, ByVal str As String, ByVal color As Integer, ByVal bkcolor As Integer, ByVal lformat As Integer) As Integer
    Private Declare Function ApAddTxt Lib "texttopdf.dll" Alias "apAddTxt" (ByVal id As Integer, ByVal lpFileName As String, ByVal color As Integer, ByVal pagewidth As Integer, ByVal pageheight As Integer, ByVal AutoNewLine As Integer, ByVal AutoWidthAdjust As Integer, ByVal LeftMargin As Integer, ByVal RightMargin As Integer, ByVal TopMargin As Integer, ByVal BottomMargin As Integer, ByVal TabSize As Integer) As Integer
    Private Declare Function ApAddLine Lib "texttopdf.dll" Alias "apAddLine" (ByVal id As Integer, ByVal sx As Integer, ByVal sy As Integer, ByVal ex As Integer, ByVal ey As Integer, ByVal side_width As Integer, ByVal side_color As Integer) As Integer
    Private Declare Function ApAddRect Lib "texttopdf.dll" Alias "apAddRect" (ByVal id As Integer, ByVal sx As Integer, ByVal sy As Integer, ByVal ex As Integer, ByVal ey As Integer, ByVal side_width As Integer, ByVal side_color As Integer, ByVal flagFill As Integer, ByVal fill_color As Integer) As Integer
    Private Declare Function ApAddInfo Lib "texttopdf.dll" Alias "apAddInfo" (ByVal id As Integer, ByVal Title As String, ByVal Subject As String, ByVal Author As String, ByVal Keywords As String, ByVal Creator As String) As Integer
    Private Declare Function ApSetFunction Lib "texttopdf.dll" Alias "apSetFunction" (ByVal id As Integer, ByVal func_code As Integer, ByVal Para1 As Integer, ByVal Para2 As Integer, ByVal szPara3 As String, ByVal szPara4 As String) As Integer
    Private Declare Function ApGetFunction Lib "texttopdf.dll" Alias "apGetFunction" (ByVal id As Integer, ByVal func_code As Integer, ByVal Para1 As Integer, ByVal Para2 As Integer, ByVal szPara3 As String, ByVal szPara4 As String) As Integer

    Dim ret
    Dim filename As String

    'define for ApAddText
    Const Ap_DT_LEFT = &H0
    Const Ap_DT_CENTER = &H1
    Const Ap_DT_RIGHT = &H2
    Const Ap_DT_WORDBREAK = &H10
    Const Ap_DT_CALCRECT = &H400
    Const Ap_DT_CALCRECTEX = &H800

    'define for ApSetFunction
    Const Ap_Set_Encrypt = 105
    Const Ap_Set_Font = 106
    Const Ap_Set_NewOrClosePage = 109
    Const Ap_Set_BookMark = 110
    Const Ap_Set_ViewerPreferences = 121
    Const Ap_Set_pageOrientation = 122

    'define for ApGetFunction
    Const Ap_Get_PdfPageCount = 206
    Const Ap_Get_PdfCurrentPageSize = 209
    Const Ap_Get_StringWidth = 250
    Const Ap_Get_StringHeight = 251

    'set password and permission
    Const permission_Print = 1
    Const permission_Copy = 2
    Const permission_Modify = 4

    Private Sub Info()

        Dim sPDF As String
        Dim id As Integer

        sPDF = "Information.pdf"
        id = ApCreate(sPDF)
        If (id > 0) Then
            'Note: set document info
            ret = ApAddInfo(id, "Title", "Subject", "Author", "Keywords", "Creator")
            'add text file to pdf
            filename = "test.txt"
            ret = ApSetFunction(id, Ap_Set_Font, 200, 16, 0, 0)
            ret = ApAddTxt(id, filename, 0, 0, 0, 1, 1, 64, 64, 64, 64, 4)
            ApClose(id)
        End If

    End Sub

    Private Sub Security()

        Dim sPDF As String
        Dim id As Integer

        sPDF = "Security.pdf"
        id = ApCreate(sPDF)
        If (id > 0) Then
            'Note: set encryption
            ret = ApSetFunction(id, Ap_Set_Encrypt, 128, permission_Print + permission_Copy + permission_Modify, "owner", "user")
            'add text file to pdf
            filename = "test.txt"
            ret = ApSetFunction(id, Ap_Set_Font, 200, 16, 0, 0)
            ret = ApAddTxt(id, filename, 0, 0, 0, 1, 1, 64, 64, 64, 64, 4)
            ApClose(id)
        End If

    End Sub

    Private Sub Bookmark()

        Dim sPDF As String
        Dim id As Integer

        sPDF = "Bookmark.pdf"
        id = ApCreate(sPDF)
        If (id > 0) Then
            'create a page for A3
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 1, 1, 0, 0)
            'add bookmark
            ret = ApSetFunction(id, Ap_Set_BookMark, 0, 0, "bookmark one", 0)
            'set system font and size
            ret = ApSetFunction(id, Ap_Set_Font, 1, 48, "Arial", 0)
            'add text
            ret = ApAddTextEx(id, 200, 200, "this is a sample!", RGB(0, 255, 255))
            'close the page
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 0, 0, 0, 0)

            'add bookmark
            ret = ApSetFunction(id, Ap_Set_BookMark, 0, 0, "bookmark two", 0)
            'add text file to pdf
            filename = "test.txt"
            ret = ApSetFunction(id, Ap_Set_Font, 200, 16, 0, 0)
            ret = ApAddTxt(id, filename, 0, 0, 0, 1, 1, 64, 64, 64, 64, 4)
            ApClose(id)
        End If

    End Sub


    Private Sub Append()

        Dim sPDF As String
        Dim id As Integer

        sPDF = "Append.pdf"
        id = ApOpen(sPDF)
        If (id > 0) Then
            'create a page for A4
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 2, 2, 0, 0)
            'set system font and size
            ret = ApSetFunction(id, Ap_Set_Font, 1, 32, "Arial", 0)
            'add text
            ret = ApAddTextEx(id, 200, 200, "Appended page", RGB(255, 0, 0))
            'close the page
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 0, 0, 0, 0)
            ApClose(id)
        Else
            id = ApCreate(sPDF)
            If (id > 0) Then
                'create a page for A4
                ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 2, 2, 0, 0)
                'set system font and size
                ret = ApSetFunction(id, Ap_Set_Font, 1, 32, "Arial", 0)
                'add text
                ret = ApAddTextEx(id, 200, 200, "First page", RGB(255, 0, 0))
                'close the page
                ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 0, 0, 0, 0)

                ApClose(id)
            End If
        End If

    End Sub

    Private Sub Composition()

        Dim sPDF As String
        Dim id As Integer
        Dim str As String
        Dim Width As Integer
        Dim Height As Integer

        sPDF = "Composition.pdf"
        id = ApCreate(sPDF)

        If (id > 0) Then

            str = "this is a sample! this is a sample! this is a sample! this is a sample!"

            'set information
            ApAddInfo(id, "Title", "Subject", "Author", "Keywords", "Creator")
            ret = ApSetFunction(id, Ap_Set_ViewerPreferences, 4 + 4096, 2, 0, 0)


            'set document info
            ret = ApAddInfo(id, "Title", "Subject", "Author", "Keywords", "Creator")
            'set encryption
            ret = ApSetFunction(id, Ap_Set_Encrypt, 128, permission_Print + permission_Copy + permission_Modify, "owner", Nothing)
            'set preferences for acrobat reader
            'thumbnail images visible.
            ret = ApSetFunction(id, Ap_Set_ViewerPreferences, 4, 0, 0, 0)

            'set page orientation
            ret = ApSetFunction(id, Ap_Set_pageOrientation, 90, 0, 0, 0)

            'create a page for A3
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 1, 1, 0, 0)
            'add bookmark
            ret = ApSetFunction(id, Ap_Set_BookMark, 0, 0, "bookmark one", 0)
            'set system font and size
            ret = ApSetFunction(id, Ap_Set_Font, 1, 48, "Helvetica", 0)
            'add text
            ret = ApAddTextEx(id, 200, 200, "this is a sample!", RGB(255, 255, 0))
            'close the page
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 0, 0, 0, 0)

            'restore page orientation
            ret = ApSetFunction(id, Ap_Set_pageOrientation, 0, 0, 0, 0)

            'create a page for A4
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 2, 2, 0, 0)
            'add bookmark
            ret = ApSetFunction(id, Ap_Set_BookMark, 0, 0, "bookmark two", 0)
            'set font and size
            ret = ApSetFunction(id, Ap_Set_Font, 203, 32, 0, 0)
            'add text for rect
            Width = 400
            Height = 200
            ret = ApAddText(id, 100, 100, Width, Height, str, RGB(0, 0, 255), RGB(255, 0, 255), Ap_DT_WORDBREAK Or Ap_DT_CENTER)
            'close the page
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 0, 0, 0, 0)

            'create a page for B5
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 4, 4, 0, 0)
            'add bookmark
            ret = ApSetFunction(id, Ap_Set_BookMark, 0, 0, "bookmark three", 0)
            'add graphic
            ret = ApAddLine(id, 10, 10, 100, 200, 5, RGB(0, 0, 255))
            ret = ApAddRect(id, 20, 210, 300, 400, 3, RGB(0, 255, 0), 1, RGB(255, 0, 255))
            'close the page
            ret = ApSetFunction(id, Ap_Set_NewOrClosePage, 0, 0, 0, 0)

            ApClose(id)

        End If
    End Sub


#Region " Windows form "

    Public Sub New()
        MyBase.New()


        InitializeComponent()



    End Sub


    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub


    Private components As System.ComponentModel.IContainer

    Friend WithEvents Button1 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Button1 = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(72, 104)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(144, 48)
        Me.Button1.TabIndex = 0
        Me.Button1.Text = "Button1"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 14)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Button1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Info()
        Security()
        Bookmark()
        Append()
        Composition()
    End Sub
End Class
